Subject: Re: [bitcoin-dev] Fees and the block-finding process

From: Mark Friedenbach <[email-masked]>
Date: Tue, 11 Aug 2015 12:00:46 -0700

More people using Bitcoin does not necessarily mean more transactions being
processed by the block chain. Satoshi was forward-thinking enough to
include a powerful script-signature system, something which has never
really existed before. Though suffering from some limitations to be sure,
this smart contract execution framework is expressive enough to enable a
wide variety of new features without changing bitcoin itself.

One of these invented features is micropayment channels -- the ability for
two parties to rapidly exchange funds while only settling the final balance
to the block chain, and to do so in an entirely trustless way. Right now
people don't use scripts to do interesting things like this, but there is
absolutely no reason why they can't. Lightning network is a vision of a
future where everyone uses a higher-layer protocol for their transactions
which only periodically settle on the block chain. It is entirely possible
that you may be able to do all your day-to-day transactions in bitcoin yet
only settle accounts every other week, totaling 13kB per year. A 1MB block
could support that level of usage by 4 million people, which is many orders
of magnitude more than the number of people presently using bitcoin on a
day to day basis.

And that, by the way, is without considering as-yet uninvented applications
of existing or future script which will provide even further improvements
to scale. This is very fertile ground being explored by very few people.
One thing I hope to come out of this block size debate is a lot more people
(like Joseph Poon) looking at how bitcoin script can be used to enable new
and innovative resource-efficient and privacy-enhancing payment protocols.

The network has room to grow. It just requires wallet developers and other
infrastructure folk to step up to the plate and do their part in deploying
this technology.

On Tue, Aug 11, 2015 at 2:14 AM, Angel Leon <[email-masked]> wrote:

> - policy neutrality.
> - It can't be censored.
> - it can't be shut down
> - and the rules cannot change from underneath you.
>
> except it can be shutdown the minute it actually gets used by its
> inability to scale.
>
> what's the point of having all this if nobody can use it?
> what's the point of going through all that energy and CO2 for a mere
> 24,000 transactions an hour?
>
> It's clear that it's just a matter of time before it collapses.
>
> Here's a simple proposal (concept) that doesn't pretend to set a fixed
> block size limit as you can't ever know the demands the future will bring
> https://gist.github.com/gubatron/143e431ee01158f27db4
>
> We don't need to go as far as countries with hyper inflation trying to use
> the technology to make it collapse, anybody here who has distributed
> commercial/free end user software knows that any small company out there
> installs more copies in a couple weeks than all the bitcoin users we have
> at the moment, all we need is a single company/project with a decent amount
> of users who are now enabled to transact directly on the blockchain to
> screw it all up (perhaps OpenBazaar this winter could make this whole thing
> come down, hopefully they'll take this debate and the current limitations
> before their release, and boy are they coding nonstop on it now that they
> got funded), the last of your fears should be a malicious government trying
> to shut you down, for that to happen you must make an impact first, for now
> this is a silly game in the grand scheme of things.
>
> And you did sound pretty bad, all of his points were very valid and they
> share the concern of many people, many investors, entrepreneurs putting
> shitload of money, time and their lives on a much larger vision than that
> of a network that does a mere 3,500 tx/hour, but some people seem to be
> able to live in impossible or useless ideals.
>
> It's simply irresponsible to not want to give the network a chance to grow
> a bit more. Miners centralizing is inevitable given the POW based
> consensus, hobbists-mining is only there for countries with very cheap
> energy.
>
> If things remain this way, this whole thing will be a massive failure and
> it will probably take another decade before we can open our mouths about
> cryptocurrencies, decentralization and what not, and this stubornness will
> be the one policy that censored everyone, that shutdown everyone, that made
> the immutable rules not matter.
>
> Perhaps it will be Stellar what ends up delivering at this stubborn pace.
>
> http://twitter.com/gubatron
>
> On Tue, Aug 11, 2015 at 4:38 AM, Thomas Zander via bitcoin-dev <
> [email-masked]> wrote:
>
>> >It follows then, that if we make a decision now which destroys that
>> property, which makes it possible to censor bitcoin, to deny service, or to
>> pressure miners into changing rules contrary to user interests, then
>> Bitcoin is no longer interesting.
>>
>> You asked to be convinced of the need for bigger blocks. I gave that.
>> What makes you think bitcoin will break when more people use it?
>>
>> Sent on the go, excuse the brevity.
>> *From: *Mark Friedenbach
>> *Sent: *Tuesday, 11 August 2015 08:10
>> *To: *Thomas Zander
>> *Cc: *Bitcoin Dev
>> *Subject: *Re: [bitcoin-dev] Fees and the block-finding process
>>
>> On Mon, Aug 10, 2015 at 11:31 PM, Thomas Zander via bitcoin-dev <
>> [email-masked]> wrote:
>>
>>> On Monday 10. August 2015 23.03.39 Mark Friedenbach wrote:
>>> > This is where things diverge. It's fine to pick a new limit or growth
>>> > trajectory. But defend it with data and reasoned analysis.
>>>
>>> We currently serve about 0,007% of the world population sending maybe one
>>> transaction a month.
>>> This can only go up.
>>>
>>> There are about 20 currencies in the world that are unstable and showing
>>> early
>>> signs of hyperinflation. If even small percentage of these people
>>> cash-out and
>>> get Bitcoins for their savings you'd have the amount of people using
>>> Bitcoin
>>> as savings go from maybe half a million to 10 million in the space of a
>>> couple
>>> of months. Why so fast? Because all the world currencies are linked.
>>> Practically all currencies follow the USD, and while that one may stay
>>> robust
>>> and standing, the linkage has been shown in the past to cause
>>> chain-effects.
>>>
>>> It is impossible to predict how much uptake Bitcoin will take, but we
>>> have
>>> seen big rises in price as Cyprus had a bailin and then when Greece first
>>> showed bad signs again.
>>> Lets do our due diligence and agree that in the current world economy
>>> there
>>> are sure signs that people are considering Bitcoin on a big scale.
>>>
>>> Bigger amount of people holding Bitcoin savings won't make the
>>> transaction
>>> rate go up very much, but if you have feet on the ground you already see
>>> that
>>> people go back to barter in countries like Poland, Ireland, Greece etc.
>>> And Bitcoin will be an alternative to good to ignore.  Then transaction
>>> rates
>>> will go up. Dramatically.
>>>
>>> If you are asking for numbers, that is a bit tricky. Again; we are at
>>> 0,007%... Thats like a f-ing rounding error in the world economy. You
>>> can't
>>> reason from that. Its like using a float to do calculations that you
>>> should
>>> have done in a double and getting weird output.
>>>
>>> Bottom line is that a maximum size of 8Mb blocks is not that odd.
>>> Because a 20
>>> times increase is very common in a "company" that is about 6 years old.
>>> For instance Android was about that age when it started to get shipped
>>> by non-
>>> Google companies. There the increase was substantially bigger and the
>>> company
>>> backing it was definitely able to change direction faster than the
>>> Bitcoin
>>> oiltanker can change direction.
>>>
>>> ...
>>>
>>> Another metric to remember; if you follow hackernews (well, the
>>> incubator more
>>> than the linked articles) you'd be exposed to the thinking of these
>>> startups.
>>> Their only criteria is growth. and this is rather substantial growth.
>>> Like
>>> 150% per month.  Naturally, most of these build on top of html or other
>>> existing technologies.  But the point is that exponential growth is
>>> expected
>>> in any startup.  They typically have a much much more agressive timeline,
>>> though. Every month instead of every year.
>>> Having exponential growth in the blockchain is really not odd and even
>>> if we
>>> have LN or sidechains or the next changetip, this space will be used.
>>> And we
>>> will still have scarcity.
>>
>>
>> I'm sorry, I really don't want to sound like a jerk, but not a single
>> word of that mattered. Yes we all want Bitcoin to scale such that every
>> person in the world can use it without difficulty. However if that were all
>> that we cared about then I would be remiss if I did not point out that
>> there are plenty of better, faster, and cheaper solutions to finding global
>> consensus over a payment ledger than Bitcoin. Architectures which are
>> algorithmically superior in their scaling properties. Indeed they are
>> already implemented and you can use them today:
>>
>> https://www.stellar.org/
>> http://opentransactions.org/
>>
>> So why do I work on Bitcoin, and why do I care about the outcome of this
>> debate? Because Bitcoin offers one thing, and one thing only which
>> alternative architectures fundamentally lack: policy neutrality. It can't
>> be censored, it can't be shut down, and the rules cannot change from
>> underneath you. *That* is what Bitcoin offers that can't be replicated at
>> higher scale with a SQL database and an audit log.
>>
>> It follows then, that if we make a decision now which destroys that
>> property, which makes it possible to censor bitcoin, to deny service, or to
>> pressure miners into changing rules contrary to user interests, then
>> Bitcoin is no longer interesting. We might as well get rid of mining at
>> that point and make Bitcoin look like Stellar or Open-Transactions because
>> at least then we'd scale even better and not be pumping millions of tons of
>> CO2 into the atmosphere from running all those ASICs.
>>
>> On the other side, 3Tb harddrives are sold, which take 8Mb blocks without
>>> problems.
>>>
>>
>> Straw man, storage is not an issue.
>>
>>
>>> You can buy broadband in every relevant country that easily supports the
>>> bandwidth we need. (remember we won't jump to 8Mb in a day, it will
>>> likely
>>> take at least 6 months).
>>>
>>
>> Neither one of those assertions is clear. Keep in mind the goal is to
>> have Bitcoin survive active censorship. Presumably that means being able to
>> run a node even in the face of a hostile ISP or government. Furthermore, it
>> means being location independent and being able to move around. In many
>> places the higher the bandwidth requirements the fewer the number of ISPs
>> that are available to service you, and the more visible you are.
>>
>> It may also be necessary to be able to run over Tor. And not just today's
>> Tor which is developed, serviced, and supported by the US government, but a
>> Tor or I2P that future governments have turned hostile towards and actively
>> censor or repress. Or existing authoritative governments, for that matter.
>> How much bandwidth would be available through those connections?
>>
>> It may hopefully never be necessary to operate under such constraints,
>> except by freedom seeking individuals within existing totalitarian regimes.
>> However the credible threat of doing so may be what keeps Bitcoin from
>> being repressed in the first place. Lose the capability to go underground,
>> and it will be pressured into regulation, eventually.
>>
>> To the second point, it has been previously pointed out that large miners
>> stand to gain from larger blocks, for the same basic underlying reasons as
>> selfish mining. The incentive is to increase blocks, and miners are able to
>> do so at will and without cost. I would not be so certain that we wouldn't
>> see large blocks sooner than that.
>>
>>
>>> We should get the inverted bloom filters stuff (or competing products)
>>> working
>>> at least on a one-to-one basis so we can solve the propagation time
>>> problem.
>>> There frankly is a huge amount of optimization that can be done in that
>>> area,
>>> we don't even use locality (pingtime) to optimize distribution.
>>> From my experience you can expect a 2-magnitude speedup in that same 6
>>> month
>>> period by focusing some research there.
>>>
>>
>> This is basically already deployed thanks to Matt's relay network.
>> Further improvements are not going to have dramatic effects.
>>
>>
>>> Remember 8Gb/block still doesn't support VISA/Mastercard.
>>>
>>
>> No, it doesn't. And 8GB/block is ludicrously large -- it would
>> absolutely, without any doubt destroy the very nature of Bitcoin, turning
>> it into a fundamentally uninteresting reincarnation of the existing
>> financial system. And still be unable to compete with VISA/Mastercard.
>>
>> So why then the pressure to go down a route that WILL lead to failure by
>> your own metrics?
>>
>> I humbly suggest that maybe we should play the strengths of Bitcoin
>> instead -- it's trustlessness via policy neutrality.
>>
>> Either that, or go work on Stellar. Because that's where it's headed
>> otherwise.
>>
>>
>> _______________________________________________
>> bitcoin-dev mailing list
>> [email-masked]
>> https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev
>>
>>
>